import { JSONWebToken } from 'jolocom-lib/js/interactionTokens/JSONWebToken';
import { CredentialOfferRequest } from 'jolocom-lib/js/interactionTokens/credentialOfferRequest';
import { InteractionChannel, SignedCredentialWithMetadata } from '../../lib/interactionManager/types';
export declare const consumeCredentialOfferRequest: (credentialOfferRequest: JSONWebToken<CredentialOfferRequest>, interactionChannel: InteractionChannel) => import("redux-thunk").ThunkAction<import("redux").AnyAction | Promise<void | import("redux").AnyAction>, import("../../reducers").RootState, import("../../backendMiddleware").BackendMiddleware, import("redux").AnyAction>;
/**
 * Given the ID for a {@link CredentialOfferFlow}, and an array representing a user selection,
 * will attempt to create the correct {@link CredentialOfferResponse} token, and pass it to the interaction
 * class instance to move the interaction forward.
 * @todo - interaction.send can throw, this is not currently handled.
 */
export declare const consumeCredentialReceive: (selectedSignedCredentialWithMetadata: SignedCredentialWithMetadata[], interactionId: string) => import("redux-thunk").ThunkAction<import("redux").AnyAction | Promise<void | import("redux").AnyAction>, import("../../reducers").RootState, import("../../backendMiddleware").BackendMiddleware, import("redux").AnyAction>;
/**
 * Given the ID for a {@link CredentialOfferFlow}, and an array representing a user selection,
 * will ensure that the user selection is sane (i.e. the user selected credentials from the offer),
 * and navigate accordingly.
 * In case the selection is sane, we try store the selected credentials and navigate to home.
 * In case the selection contains SOME entries which can't be saved (i.e. wrong issuer / subject, already stored),
 * we navigate to the selection screen again, with the problematic credentials marked as invalid (and therefore unselectable)
 * In case the selection contains NO entries that can be saved, a error notification is rendered, and the interaction is ended.
 *
 * @dev This function can eventually be simplified. It currently contains a bunch of logic which is not well abstracted / does not fit anywhere else
 * (e.g. checking for duplicates)
 */
export declare const validateSelectionAndSave: (selectedCredentials: SignedCredentialWithMetadata[], interactionId: string) => import("redux-thunk").ThunkAction<import("redux").AnyAction | Promise<void | import("redux").AnyAction>, import("../../reducers").RootState, import("../../backendMiddleware").BackendMiddleware, import("redux").AnyAction>;
