'use strict';Object.defineProperty(exports,'__esModule',{value:true});const tslib_1=require('tslib');const types_1=require('jolocom-lib/js/interactionTokens/types');const ramda_1=require('ramda');const flow_1=require('./flow');const guards_1=require('./guards');class CredentialOfferFlow extends flow_1.Flow{constructor(ctx){super(ctx);this.state={offerSummary:[],selection:[],issued:[]};}handleInteractionToken(token,messageType){return tslib_1.__awaiter(this,void 0,void 0,function*(){switch(messageType){case types_1.InteractionType.CredentialOfferRequest:if(guards_1.isCredentialOfferRequest(token))return this.handleOfferRequest(token);case types_1.InteractionType.CredentialOfferResponse:if(guards_1.isCredentialOfferResponse(token))return this.handleOfferResponse(token);case types_1.InteractionType.CredentialsReceive:if(guards_1.isCredentialReceive(token))return this.handleCredentialReceive(token);default:throw new Error('Interaction type not found');}});}handleOfferRequest(offer){this.state.offerSummary=offer.offeredCredentials;return true;}handleOfferResponse(token){return tslib_1.__awaiter(this,void 0,void 0,function*(){this.state.selection=token.selectedCredentials;return true;});}handleCredentialReceive({signedCredentials}){this.state.issued=signedCredentials;this.state.issued.map(cred=>{const offer=this.state.offerSummary.find(({type})=>type===ramda_1.last(cred.type));if(!offer){throw new Error('Received wrong credentials');}});return true;}getSelectionResult(){const offeredTypes=this.state.offerSummary.map(o=>o.type);const selectedTypes=this.state.selection.map(s=>s.type);return offeredTypes.filter(ot=>selectedTypes.includes(ot));}getIssuanceResult(){return this.state.issued.map(cred=>{const offer=this.state.offerSummary.find(({type})=>type===ramda_1.last(cred.type));if(!offer){throw new Error('Received wrong credentials');}return Object.assign(Object.assign({},offer),{signedCredential:cred,validationErrors:{invalidIssuer:cred.issuer!==this.ctx.participants.requester.did,invalidSubject:cred.subject!==this.ctx.participants.responder.did}});});}}exports.CredentialOfferFlow=CredentialOfferFlow;